Subject: Re: PATCH: fix bridged 802.3ad bonding

From: Stephen Hemminger <[email-masked]>
Date: Tue, 3 Jun 2008 09:46:04 -0700

On Tue, 3 Jun 2008 15:21:06 +0200
Jiri Bohac <[email-masked]> wrote:

> Hi,
> 
> Bonding in 802.3ad mode breaks when the bond interface is added
> to a bridge (which makes 802.3ad unusable in XEN, for example).
> 
> The problem is that br_pass_frame_up() will change the skb's dev
> pointer to point to the bridge interface. As a result, the LACP
> packets will not reach the bond_3ad_lacpdu_recv() protocol
> handler registered on the bonding device. Even if they did, the
> handler won't work with the changed skb->dev.
> 
> The following patch fixes the problem.
> 
> Signed-off-by: Jiri Bohac <[email-masked]>

Agree with Patrick, it might be a real problem but your solution
is doing it in the wrong place. The packets do arrive on the bridge
interface which is an aggregation of all the interfaces in the bridge.

The LACPDU's are received via now on the bond device. If you moved
the packet type handler down to the physical interface, this problem
would go away because the packets would be handled to bond_3ad_lacpdu_recv
prior to being handled by the bridge.  You would still have to handle
cases where bonding device was inactive, but that shouldn't be hard.